//------------------------------------------------------------------------
//
// OpenDCC - OpenDecoder
//
// Copyright (c) 2007 Kufer
//
// This source file is subject of the GNU general public license 2,
// that is available at the world-wide-web at
// http://www.gnu.org/licenses/gpl.txt
// 
//------------------------------------------------------------------------
//
// file:      port_engine.h
// author:    Wolfgang Kufer
// contact:   kufer@gmx.de
// webpage:   http://www.opendcc.de
// history:   2007-02-14 V0.1 kw copied from opendecoder.c
//            2008-11-23 V0.2 kw CurrentBlink added
//
//------------------------------------------------------------------------
//
// purpose:   flexible general purpose decoder for dcc
//            here: hardware defintions
//
//------------------------------------------------------------------------

#ifndef _DIMM_ENGINE_H_
#define _DIMM_ENGINE_H_

// Definitions

//#define SIZE_OUT_PWM	8
#define NUM_SIGNAL		4

// performs the command 

void init_dimm_engine(void);

void simple_preset(unsigned char command);

void Dimmer(void);

void action(unsigned int Command, unsigned char Activate);

extern unsigned char		CurrentTarget[NUM_SIGNAL];
extern unsigned char		CurrentBlink[NUM_SIGNAL];
extern volatile	uint8_t	signalData[NUM_SIGNAL];
extern unsigned char		Display_MainSign;					// HauptSignal anzeigen
extern unsigned char		Display_PrevSign;					// VorSignal anzeigen

// general support routines

void turn_led_on(void);
  
void turn_led_off(void);
  
void flash_led_fast(unsigned char count);

// internal

#endif  // _DIMM_ENGINE_H_
